// COPYRIGHT LICENSE:  This information contains sample code provided in source code form.
// You may copy, modify, and distribute these sample programs in any form without payment
// to IBM for the purposes of developing, using, marketing or distributing application
// programs conforming to the application programming interface for the operating platform
// for which the sample code is written. Notwithstanding anything to the contrary,
// IBM PROVIDES THE SAMPLE SOURCE CODE ON AN "AS IS" BASIS AND IBM DISCLAIMS ALL WARRANTIES,
// EXPRESS OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, ANY IMPLIED WARRANTIES OR CONDITIONS
// OF MERCHANTABILITY, SATISFACTORY QUALITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE, AND
// ANY WARRANTY OR CONDITION OF NON-INFRINGEMENT.  IBM SHALL NOT BE LIABLE FOR ANY DIRECT,
// INDIRECT, INCIDENTAL, SPECIAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR
// OPERATION OF THE SAMPLE SOURCE CODE.  IBM HAS NO OBLIGATION TO PROVIDE MAINTENANCE,
// SUPPORT, UPDATES, ENHANCEMENTS OR MODIFICATIONS TO THE SAMPLE SOURCE CODE.
//
// (C) Copyright IBM Corp. 2011, 2012.
// All Rights Reserved. Licensed Materials - Property of IBM.

package com.ibm.ws.batch.ilc.sample;

import com.ibm.ws.batch.ilc.impl.ILProcedureImpl;
import com.ibm.ws.batch.ilc.sample.parameters.ILCEMPREC;

public class COBEMP extends ILProcedureImpl {

  private ILCEMPREC _iLCEMPREC;

  private static int ILCEMPREC = 0;

  public COBEMP() {
    super("COBEMP",             // Cobol Load Module
      "COBEMP",                 // Procedure entry point
      1,                        // the parameter count (01 level), including return value (unless rv is simple scalar)
      "Unknown Build",          // user-defined build identifier
      "2011/04/21 11:55:38",    // stub generation date
      null);                    // optional, user defined test stub

    _iLCEMPREC = new ILCEMPREC();

  }

  public byte[][] getParmList() { 
    byte[][] parmList = super.getParmList();
    parmList[ILCEMPREC] = _iLCEMPREC.getBytes();
    return parmList;
  }

  /**
   * <pre>LINKAGE SECTION.
   *  01 ILCEMPREC.
   *     COPY ILCEMP.
   * </pre>
   */
  public ILCEMPREC getILCEMPREC() {
    return _iLCEMPREC;
  }

}
