// COPYRIGHT LICENSE:  This information contains sample code provided in source code form.
// You may copy, modify, and distribute these sample programs in any form without payment
// to IBM for the purposes of developing, using, marketing or distributing application
// programs conforming to the application programming interface for the operating platform
// for which the sample code is written. Notwithstanding anything to the contrary,
// IBM PROVIDES THE SAMPLE SOURCE CODE ON AN "AS IS" BASIS AND IBM DISCLAIMS ALL WARRANTIES,
// EXPRESS OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, ANY IMPLIED WARRANTIES OR CONDITIONS
// OF MERCHANTABILITY, SATISFACTORY QUALITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE, AND
// ANY WARRANTY OR CONDITION OF NON-INFRINGEMENT.  IBM SHALL NOT BE LIABLE FOR ANY DIRECT,
// INDIRECT, INCIDENTAL, SPECIAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR
// OPERATION OF THE SAMPLE SOURCE CODE.  IBM HAS NO OBLIGATION TO PROVIDE MAINTENANCE,
// SUPPORT, UPDATES, ENHANCEMENTS OR MODIFICATIONS TO THE SAMPLE SOURCE CODE.
//
// (C) Copyright IBM Corp. 2011, 2012.
// All Rights Reserved. Licensed Materials - Property of IBM.

package com.ibm.ws.batch.ilc.sample;

import com.ibm.ws.batch.ilc.impl.ILProcedureImpl;
import com.ibm.ws.batch.ilc.sample.parameters.HC_OP;
import com.ibm.ws.batch.ilc.sample.parameters.ILCEMPREC;
import com.ibm.ws.batch.ilc.sample.parameters.HC_RC;

public class HOLDCURS extends ILProcedureImpl {

  private HC_OP _hC_OP;
  private ILCEMPREC _iLCEMPREC;
  private HC_RC _hC_RC;

  private static int HC_OP = 0;
  private static int ILCEMPREC = 1;

  public HOLDCURS() {
    super("HOLDCURS",           // Cobol Load Module
      "HOLDCURS",               // Procedure entry point
      3,                        // the parameter count (01 level), including return value (unless rv is simple scalar)
      "Unknown Build",          // user-defined build identifier
      "2011/04/21 11:55:38",    // stub generation date
      null);                    // optional, user defined test stub

    _hC_RC = new HC_RC();

    _hC_OP = new HC_OP();

    _iLCEMPREC = new ILCEMPREC();

  }

  public byte[][] getParmList() { 
    byte[][] parmList = super.getParmList();
    parmList[HC_OP] = _hC_OP.getBytes();
    parmList[ILCEMPREC] = _iLCEMPREC.getBytes();
    return parmList;
  }

  /**
   * <pre>LINKAGE SECTION.
   *  77 HC-RC                      PIC S9(9) COMP-5.
   *                                                                   
   * </pre>
   */
  public HC_RC getReturnValue() {
    return _hC_RC;
  }

  public void setReturnCode(int rc) {
    byte[] bytes = _hC_RC.getBytes();
    for (int i = bytes.length-1; i >= 0; --i)
      bytes[i] = (byte) (rc >>> ((bytes.length-1-i)*8));
  }

  /**
   * <pre>LINKAGE SECTION.
   *  77 HC-OP                      PIC S9(9) COMP-5.
   * </pre>
   */
  public HC_OP getHC_OP() {
    return _hC_OP;
  }

  /**
   * <pre>LINKAGE SECTION.
   *  01 ILCEMPREC.
   *     COPY ILCEMP.                          
   * </pre>
   */
  public ILCEMPREC getILCEMPREC() {
    return _iLCEMPREC;
  }

}
