// COPYRIGHT LICENSE:  This information contains sample code provided in source code form.
// You may copy, modify, and distribute these sample programs in any form without payment
// to IBM for the purposes of developing, using, marketing or distributing application
// programs conforming to the application programming interface for the operating platform
// for which the sample code is written. Notwithstanding anything to the contrary,
// IBM PROVIDES THE SAMPLE SOURCE CODE ON AN "AS IS" BASIS AND IBM DISCLAIMS ALL WARRANTIES,
// EXPRESS OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, ANY IMPLIED WARRANTIES OR CONDITIONS
// OF MERCHANTABILITY, SATISFACTORY QUALITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE, AND
// ANY WARRANTY OR CONDITION OF NON-INFRINGEMENT.  IBM SHALL NOT BE LIABLE FOR ANY DIRECT,
// INDIRECT, INCIDENTAL, SPECIAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR
// OPERATION OF THE SAMPLE SOURCE CODE.  IBM HAS NO OBLIGATION TO PROVIDE MAINTENANCE,
// SUPPORT, UPDATES, ENHANCEMENTS OR MODIFICATIONS TO THE SAMPLE SOURCE CODE.
//
// (C) Copyright IBM Corp. 2011, 2012.
// All Rights Reserved. Licensed Materials - Property of IBM.

package com.ibm.ws.batch.ilc.sample.PRIMITVE;

import com.ibm.ws.batch.ilc.impl.ILProcedureImpl;
import com.ibm.ws.batch.ilc.sample.PRIMITVE.parameters.PRIMITVE_DFHCOMMAREA;
import com.ibm.ws.batch.ilc.sample.PRIMITVE.parameters.PRIMITVE_RetDecBigDec;

public class PRIMITVE extends ILProcedureImpl {

  private PRIMITVE_DFHCOMMAREA _dFHCOMMAREA;
  private PRIMITVE_RetDecBigDec _retDecBigDec;

  private static int DFHCOMMAREA = 0;

  public PRIMITVE() {
    super("PRIMITVE",           // Cobol Load Module
      "PRIMITVE",               // Procedure entry point
      2,                        // the parameter count (01 level), including return value (unless rv is simple scalar)
      "Unknown Build",          // user-defined build identifier
      "2011/04/21 11:55:35",    // stub generation date
      null);                    // optional, user defined test stub

    _retDecBigDec = new PRIMITVE_RetDecBigDec();

    _dFHCOMMAREA = new PRIMITVE_DFHCOMMAREA();

  }

  public byte[][] getParmList() { 
    byte[][] parmList = super.getParmList();
    parmList[DFHCOMMAREA] = _dFHCOMMAREA.getBytes();
    return parmList;
  }

  /**
   * <pre>LINKAGE SECTION.
   *  01  RetDecBigDec     PIC S999V9 BINARY.
   * </pre>
   */
  public PRIMITVE_RetDecBigDec getReturnValue() {
    return _retDecBigDec;
  }

  public void setReturnCode(int rc) {
    byte[] bytes = _retDecBigDec.getBytes();
    for (int i = bytes.length-1; i >= 0; --i)
      bytes[i] = (byte) (rc >>> ((bytes.length-1-i)*8));
  }

  /**
   * <pre>LINKAGE SECTION.
   *  01  DFHCOMMAREA.
   *      02  UsZoneDec    PIC 999V9 DISPLAY.
   *      02  SZoneDec     PIC S999V9 DISPLAY.
   *      02  ZoneDecSL    PIC S999V9 DISPLAY SIGN LEADING.
   *      02  ZoneDecSLS   PIC S999V9 DISPLAY SIGN LEADING SEPARATE.
   *      02  ZoneDecSTS   PIC S999V9 DISPLAY SIGN TRAILING SEPARATE.
   *      02  UsPackDec    PIC 999V9 COMP-3.
   *      02  SPackDec     PIC S999V9 COMP-3.
   *      02  UsBinary     PIC 9999 BINARY.
   *      02  SBinary      PIC S9999 BINARY.
   *      02  SBinaryDec   PIC S999V9 BINARY.
   *      02  InterFloat   COMP-1.
   *      02  InterDouble  COMP-2.
   *      02  ExternFP     PIC +9(2).9(2)E+99 DISPLAY.
   *      02  SingleChar   PIC X(1).
   *      02  PICXStr      PIC X(12).
   *      02  PICAStr      PIC A(20).
   *      02  DecByte      PIC S9 BINARY.
   *      02  DecShort     PIC S99 BINARY.
   *      02  DecInt       PIC S999999 BINARY.
   *      02  DecLong      PIC S9999999999 BINARY.
   *      02  DecBigDec    PIC S999V9 BINARY.
   *      02  DecIntArray  PIC S999999 BINARY OCCURS 5 TIMES.
   * </pre>
   */
  public PRIMITVE_DFHCOMMAREA getPRIMITVE_DFHCOMMAREA() {
    return _dFHCOMMAREA;
  }

}
