// COPYRIGHT LICENSE:  This information contains sample code provided in source code form.
// You may copy, modify, and distribute these sample programs in any form without payment
// to IBM for the purposes of developing, using, marketing or distributing application
// programs conforming to the application programming interface for the operating platform
// for which the sample code is written. Notwithstanding anything to the contrary,
// IBM PROVIDES THE SAMPLE SOURCE CODE ON AN "AS IS" BASIS AND IBM DISCLAIMS ALL WARRANTIES,
// EXPRESS OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, ANY IMPLIED WARRANTIES OR CONDITIONS
// OF MERCHANTABILITY, SATISFACTORY QUALITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE, AND
// ANY WARRANTY OR CONDITION OF NON-INFRINGEMENT.  IBM SHALL NOT BE LIABLE FOR ANY DIRECT,
// INDIRECT, INCIDENTAL, SPECIAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR
// OPERATION OF THE SAMPLE SOURCE CODE.  IBM HAS NO OBLIGATION TO PROVIDE MAINTENANCE,
// SUPPORT, UPDATES, ENHANCEMENTS OR MODIFICATIONS TO THE SAMPLE SOURCE CODE.
//
// (C) Copyright IBM Corp. 2011, 2012.
// All Rights Reserved. Licensed Materials - Property of IBM.

package com.ibm.ws.batch.ilc.sample.bds;

import java.io.BufferedReader;
import java.io.IOException;
import java.util.Properties;
import java.util.logging.Logger;

import com.ibm.websphere.batch.devframework.datastreams.patternadapter.FileReaderPattern;
import com.ibm.ws.batch.ilc.sample.ILCEmpRecord;

public class ILCEmpFileReader implements FileReaderPattern
{
  private static final String _cName = ILCEmpFileReader.class.getName();
  private static Logger logger = Logger.getLogger(_cName);

  public Object fetchHeader()
  {
    return ILCEmpRecord.getInputFieldMap();
  }

  public Object fetchRecord(BufferedReader reader) throws IOException
  {
    ILCEmpRecord ilcEmpRecord = null;

    String rec = reader.readLine();

    if (rec != null)
      ilcEmpRecord = new ILCEmpRecord(rec);

    return ilcEmpRecord;
  }

  public void initialize(Properties props)
  {
  }

  public void processHeader(BufferedReader reader) throws IOException
  {
    String inputFieldMapStr = reader.readLine();

    if (inputFieldMapStr != null)
      ILCEmpRecord.setInputFieldMap(inputFieldMapStr);

    logger.fine("set field map: " + inputFieldMapStr);
  }

}
