// COPYRIGHT LICENSE:  This information contains sample code provided in source code form.
// You may copy, modify, and distribute these sample programs in any form without payment
// to IBM for the purposes of developing, using, marketing or distributing application
// programs conforming to the application programming interface for the operating platform
// for which the sample code is written. Notwithstanding anything to the contrary,
// IBM PROVIDES THE SAMPLE SOURCE CODE ON AN "AS IS" BASIS AND IBM DISCLAIMS ALL WARRANTIES,
// EXPRESS OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, ANY IMPLIED WARRANTIES OR CONDITIONS
// OF MERCHANTABILITY, SATISFACTORY QUALITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE, AND
// ANY WARRANTY OR CONDITION OF NON-INFRINGEMENT.  IBM SHALL NOT BE LIABLE FOR ANY DIRECT,
// INDIRECT, INCIDENTAL, SPECIAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR
// OPERATION OF THE SAMPLE SOURCE CODE.  IBM HAS NO OBLIGATION TO PROVIDE MAINTENANCE,
// SUPPORT, UPDATES, ENHANCEMENTS OR MODIFICATIONS TO THE SAMPLE SOURCE CODE.
//
// (C) Copyright IBM Corp. 2011, 2012.
// All Rights Reserved. Licensed Materials - Property of IBM.

package com.ibm.ws.batch.ilc.sample.bds;

import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.util.Properties;
import java.util.logging.Logger;

import com.ibm.websphere.batch.devframework.datastreams.patternadapter.JDBCWriterPattern;
import com.ibm.ws.batch.ilc.sample.ILCEmpRecord;

public class ILCEmpJdbcWriter implements JDBCWriterPattern
{
  private static final String _cName = ILCEmpJdbcWriter.class.getName();
  private static Logger logger = Logger.getLogger(_cName);

  private Properties _props = null;

  public String getSQLQuery()
  {
    String sql = _props.getProperty("update.sql");

    if (sql == null || sql.length() == 0)
      sql = "UPDATE ILCSCHEMA.EMP SET EDLEVEL = ?, SALARY = ? WHERE EMPNO = ?";

    logger.fine("getSQLQuery: " + sql);

    return sql;
  }

  public void initialize(Properties props)
  {
    _props = props;
  }

  public PreparedStatement writeRecord(PreparedStatement pstmt, Object record)
  {
    ILCEmpRecord ilcEmpRecord = (ILCEmpRecord)record;

    try
    {
      pstmt.setShort(1, ilcEmpRecord.getEDLEVEL());
      pstmt.setBigDecimal(2, ilcEmpRecord.getSALARY());
      pstmt.setShort(3, ilcEmpRecord.getEMPNO());

      logger.fine("writeRecord PrepartedStatement: " + pstmt);
    }
    catch (SQLException e)
    {
      throw new RuntimeException(e);
    }

    return pstmt;
  }

}
